#include <iostream>

using namespace std;

class Widzet
{
public:
	virtual void rysuj() = 0;
};

class Okno : public Widzet
{
	int wysokosc;
	int szerokosc;
public:
	~Okno(){
		cout << "Usuniecie!" << endl;
	}
	Okno(int wysokosc, int szerokosc)
	{
		this->wysokosc = wysokosc;
		this->szerokosc = szerokosc;
	}
	void rysuj()
	{
		cout << "Okno o wymiarach, szerokosc: " << szerokosc << " wysokosc: " << wysokosc << endl;
	}
};

class Dekorator : public Widzet
{
	Widzet * widzet;
public:
	~Dekorator(){
		delete widzet;
	}
	Dekorator(Widzet * widzet)
	{
		this->widzet = widzet;
	}
	void rysuj()
	{
		widzet->rysuj();
	}
};

class ObramowanieOknaDekorator : public Dekorator
{
public:
	ObramowanieOknaDekorator(Widzet * widzet) : Dekorator(widzet){};
	

	void rysuj()
	{
		Dekorator::rysuj();
		cout << "Obramowanie okna" << endl;
	}
};

class PasekPrzewijaniaPionowyDekorator : public Dekorator
{
public:
	PasekPrzewijaniaPionowyDekorator(Widzet * widzet) : Dekorator(widzet){};

	void rysuj()
	{
		Dekorator::rysuj();
		cout << "Dodanie paska przewijania pionowego" << endl;
	}
};

/*
int main()
{
	
	Widzet * widzet = new Okno(50,15);
	widzet = new ObramowanieOknaDekorator(widzet);
	widzet = new PasekPrzewijaniaPionowyDekorator(widzet);
	widzet = new ObramowanieOknaDekorator(widzet);
	
	widzet->rysuj();
	
	delete widzet;
	
	return 0;
}
*/